FUNCTION poptell
PARAMETERS p_mess, wait_time, s_row, s_col
PRIVATE p_mess, s_row, s_col, wait_time, mess_len
PRIVATE m_key, cur_curs

***  Function pops a message on the screen for a 
***  specified number of seconds.

***  check our parameters!

p_mess = iif(pcount() = 0, 'Press any key.....', ;
             p_mess)
wait_time = iif(pcount() < 2, iif(pcount()= 0, ;
                0, 3), wait_time)
s_row = iif(pcount() < 3, 9, s_row)
s_col = iif(pcount() = 4, s_col, ;
            36 - int(len(p_mess)/2))

***  Are the parameter types OK? 

IF type('p_mess') = 'C' .and. ;
   type('s_row') = 'N'  .and. ;
   type('s_col') = 'N'  .and. ;
   type('wait_time') = 'N'

***  Does window fit on the screen?

  p_mess = iif(len(p_mess)>74, left(p_mess,74),;
               p_mess)
  mess_len = len(p_mess)
  s_row = min(s_row,iif(set('status') = 'ON', ;
              17,20))
  s_col = min(74-mess_len,s_col)

***  do it!

  DEFINE WINDOW p_tel FROM s_row, s_col ;
                TO s_row+4,s_col+mess_len+5 ;
                DOUBLE
  ACTIVATE WINDOW p_tel

***  hide the cursor

  cur_curs = set('cursor') = 'ON'
  SET CURSOR OFF

  @ 1,2 SAY p_mess
  m_key = inkey(wait_time)
  RELEASE WINDOW p_tel

***  get the cursor back

  IF cur_curs
    SET CURSOR ON
  ENDIF

  RETURN(upper(chr(m_key)))
ELSE                &&  bad parameters
  RETURN('')        &&  null value
ENDIF

********  EOP poptell


