DO CASE
  CASE upper(pb)="EDIT"
    ** get a copy of the record
    SCATTER MEMVAR MEMO 
    ** store a second copy of the record in an array for later
    ** use in determining whether the record should be saved
    SCATTER TO old MEMO
    ** give the user access to the the GETs
    SHOW GETS ENABLED
    ** disable any unique key
    SHOW GET m.cu_custid DISABLED
    ** put the cursor in the company field
    _curobj=OBJNUM(m.cu_company)
    ** go back to editing the record
    RETURN .T.
  CASE upper(pb)="SAVE"
    ** save changes to record
    IF !RLOCK()
      ** can't save this user's changes!
      DO l2msg WITH "Sorry. Someone else is changing this record."+;
      " Your changes will NOT BE SAVED!","Ok"
    ELSE
      ** since a record lock insures a current copy of the record,
      ** put this new copy into an array for comparison with the 
      ** original version of the record.
      SCATTER TO new MEMO
      ** Now, compare the old and new arrays
      FOR l_xx 1 TO ALEN(new)
        IF NOT old(l_xx)==new(l_xx)
          ** The record has changed from the time the user placed
          ** a copy of the record in memory!
          EXIT
        ENDIF
      ENDFOR
      IF l_xx<=ALEN(new)
        ** not all of the elements matched in the two arrays, so
        ** this record was changed by another user while this user
        ** was editing.
        UNLOCK
        DO l2msg with "Sorry. Either you started out with an old copy"+;
          " of this record, or someone changed it on you while you"+;
          " were editing. Your changes WILL NOT BE SAVED!","Ok"
      ELSE
        ** Hurray! He's been working with the current record, and nobody
        ** else changed it while he was editing!
        GATHER MEMVAR MEMO  && save memvars to current record
        UNLOCK
      ENDIF was working with an old copy 
    ENDIF not able to lock
    ** kill the other gets
    SHOW GETS DISABLED
    ** give them a push button to work with
    SHOW GET pb ENABLED
  CASE upper(pb)="ABORT"
    ** Reset the memory variables
    SCATTER MEMVAR MEMO
    ** kill the other gets
    SHOW GETS DISABLED
    ** give them a push button to work with
    SHOW GET pb ENABLED
ENDCASE
RETURN .T.    


